#!/usr/bin/env python
# coding:utf8
from __future__ import unicode_literals
import json
import pandas as pd
import numpy as np
import csv


nodes = []
links = []

soundList = []
directList = []
supeList = []
chnameList = []
proList = []
designList = []
typeList = []
firstList = []

#中心节点
nodes.append({'id': '动漫', 'class': 'anime', 'group': 0, 'size': 22})

#类型节点
NAMES = ['角色设计','类型','主要配音','出品','导演','中文名','首播电视台','作画监督']
data = pd.read_csv("all.csv", names=NAMES, sep =str(","), engine = 'python', encoding="utf-8")
for index, row in data.iterrows():
    value = row['类型']
    if not (value == "无信息"):
        nodes.append({'id': row['中文名'], 'class': 'chname', 'group': 2, 'size': 13})

        if value.find("~") >= 0:
            v = value.split("~")
        elif value.find(" ") >= 0:
            v = value.split(" ")
        else:
            v = [value]
        for indexs in v:
            if not (indexs in typeList):
                typeList.append(indexs)
                nodes.append({'id': indexs, 'class': 'type', 'group': 1, 'size': 20})
                links.append({'source': '动漫', 'target': indexs, 'value': 3})
                links.append({'source': indexs, 'target': '动漫', 'value': 3})

                links.append({'source': row['中文名'], 'target': indexs, 'value': 3})
                links.append({'source': indexs, 'target': row['中文名'], 'value': 3})


        nodes.append({'id': row['中文名'] + "主要配音", 'class': 'sounds', 'group': 3, 'size': 13})
        links.append({'source': row['中文名'], 'target': row['中文名'] + '主要配音', 'value': 3})
        links.append({'source': row['中文名'] + '主要配音', 'target': row['中文名'], 'value': 3})

        nodes.append({'id': row['中文名'] + "作画监督", 'class': 'supres', 'group': 4, 'size': 13})
        links.append({'source': row['中文名'], 'target': row['中文名'] + '作画监督', 'value': 3})
        links.append({'source': row['中文名'] + '作画监督', 'target': row['中文名'], 'value': 3})

        nodes.append({'id': row['中文名'] + "角色设计", 'class': 'designs', 'group': 5, 'size': 13})
        links.append({'source': row['中文名'], 'target': row['中文名'] + '角色设计', 'value': 3})
        links.append({'source': row['中文名'] + '角色设计', 'target': row['中文名'], 'value': 3})

        value = row['主要配音']
        if value.find("~") >= 0:
            v = value.split("~")
        else:
            v = [value]
        for indexs in v:
            if not (indexs == "无信息"):
                if indexs not in soundList:
                    soundList.append(indexs)
                    nodes.append({'id': indexs, 'class': 'sound', 'group': 6, 'size': 13})
                links.append({'source': row['中文名'] + '主要配音', 'target': indexs, 'value': 3})
                links.append({'source': indexs, 'target': row['中文名'] + '主要配音', 'value': 3})

        value = row['导演']
        if not (value == "无信息"):
            if value not in directList:
                directList.append(value)
                nodes.append({'id': value, 'class': 'director', 'group': 7, 'size': 13})
            links.append({'source': row['中文名'], 'target': value, 'value': 3})
            links.append({'source': value, 'target': row['中文名'], 'value': 3})

        value = row['作画监督']
        if value.find("~") >= 0:
            v = value.split("~")
        else:
            v = [value]
        for indexs in v:
            if not (indexs == "无信息"):
                if indexs not in supeList:
                    supeList.append(indexs)
                    nodes.append({'id': indexs, 'class': 'supre', 'group': 8, 'size': 13})
                links.append({'source': row['中文名'] + '作画监督', 'target': indexs, 'value': 3})
                links.append({'source': indexs, 'target': row['中文名'] + '作画监督', 'value': 3})

        value = row['出品']
        if not (value == "无信息"):
            if value not in proList:
                proList.append(value)
                nodes.append({'id': value, 'class': 'produce', 'group': 9, 'size': 13})
            links.append({'source': row['中文名'], 'target': value, 'value': 3})
            links.append({'source': value, 'target': row['中文名'], 'value': 3})

        value = row['角色设计']
        if value.find("~") >= 0:
            v = value.split("~")
        else:
            v = [value]
        for indexs in v:
            if not (indexs == "无信息"):
                if indexs not in designList:
                    designList.append(indexs)
                    nodes.append({'id': indexs, 'class': 'design', 'group': 10, 'size': 13})
                links.append({'source': row['中文名'] + '角色设计', 'target': indexs, 'value': 3})
                links.append({'source': indexs, 'target': row['中文名'] + '角色设计', 'value': 3})

        value = row['首播电视台']
        if not (value == "无信息"):
            if value not in firstList:
                firstList.append(value)
                nodes.append({'id': value, 'class': 'first', 'group': 11, 'size': 13})
            links.append({'source': row['中文名'], 'target': value, 'value': 3})
            links.append({'source': value, 'target': row['中文名'], 'value': 3})



fw = open('nodes.json', 'w', encoding="utf-8")
fw.write(json.dumps({'nodes': nodes, 'links': links}, ensure_ascii=False))
fw.close()
